<?php
include_once(dirname(__FILE__)."/class.mysql.inc");
include_once(dirname(__FILE__)."/class.groups.inc");

class compile_ufdbguard{
	var $SquidGuardIPWeb;
	var $EnableRemoteStatisticsAppliance=0;
	var $EnableWebProxyStatsAppliance=0;
	
	function compile_ufdbguard(){
		$GLOBALS["SRC"]=array();
		$sock=new sockets();
		$usrs=new usersMenus();
		$this->SquidGuardIPWeb=$sock->GET_INFO("SquidGuardIPWeb");
		if($this->SquidGuardIPWeb==null){$this->SquidGuardIPWeb="http://$usrs->hostname:9020/exec.squidguard.php";}
		$this->SquidGuardIPWeb=str_replace('.(none)',"",$this->SquidGuardIPWeb);
		$this->EnableRemoteStatisticsAppliance=$sock->GET_INFO("EnableRemoteStatisticsAppliance");
		$this->EnableWebProxyStatsAppliance=$sock->GET_INFO("EnableWebProxyStatsAppliance");
		$this->SquidDatabasesUtlseEnable=$sock->GET_INFO("SquidDatabasesUtlseEnable");
		
		if(!is_numeric($this->EnableRemoteStatisticsAppliance)){$this->EnableRemoteStatisticsAppliance=0;}
		if(!is_numeric($this->SquidDatabasesUtlseEnable)){$this->SquidDatabasesUtlseEnable=1;}
		if(!is_numeric($this->EnableWebProxyStatsAppliance)){$this->EnableWebProxyStatsAppliance=0;}
		
	}
	
	
	public function buildConfig(){
		$sock=new sockets();
		$sources=$this->build_sources();
		$times=$this->build_times();
		$categories=$this->build_categories();
		$acls=$this->build_acls();
		if(!preg_match("#squidguard\.php#",$this->SquidGuardIPWeb)){$this->SquidGuardIPWeb=$this->SquidGuardIPWeb."/exec.squidguard.php?";}
		$conf[]="dbhome /var/lib/squidguard";
		$conf[]="logdir /var/log/squid";

		
				
		
	
		$ufdbguardConfig=unserialize(base64_decode($sock->GET_INFO("ufdbguardConfig")));
		if(!isset($ufdbguardConfig["enforce-https-with-hostname"])){$ufdbguardConfig["enforce-https-with-hostname"]=0;}
		if(!isset($ufdbguardConfig["enforce-https-official-certificate"])){$ufdbguardConfig["enforce-https-official-certificate"]=0;}
		if(!isset($ufdbguardConfig["https-prohibit-insecure-sslv2"])){$ufdbguardConfig["https-prohibit-insecure-sslv2"]=0;}
		if(!isset($ufdbguardConfig["url-lookup-result-during-database-reload"])){$ufdbguardConfig["url-lookup-result-during-database-reload"]=1;}
		if(!isset($ufdbguardConfig["url-lookup-result-when-fatal-error"])){$ufdbguardConfig["url-lookup-result-when-fatal-error"]=1;}
		if(!isset($ufdbguardConfig["check-proxy-tunnel"])){$ufdbguardConfig["check-proxy-tunnel"]=1;}
		
		if($ufdbguardConfig["enforce-https-with-hostname"]==null){$ufdbguardConfig["enforce-https-with-hostname"]=0;}
		if($ufdbguardConfig["enforce-https-official-certificate"]==null){$ufdbguardConfig["enforce-https-official-certificate"]=0;}
		if($ufdbguardConfig["https-prohibit-insecure-sslv2"]==null){$ufdbguardConfig["https-prohibit-insecure-sslv2"]=0;}	
		if(!is_numeric($ufdbguardConfig["url-lookup-result-during-database-reload"])){$ufdbguardConfig["url-lookup-result-during-database-reload"]=1;}
		if(!is_numeric($ufdbguardConfig["url-lookup-result-when-fatal-error"])){$ufdbguardConfig["url-lookup-result-when-fatal-error"]=1;}				
		if(!is_numeric($ufdbguardConfig["check-proxy-tunnel"])){$ufdbguardConfig["check-proxy-tunnel"]=1;}
			
		if($ufdbguardConfig["url-lookup-result-during-database-reload"]==1){
			$conf[]="url-lookup-result-during-database-reload deny";
			$conf[]="redirect-loading-database \"$this->SquidGuardIPWeb?loading-database=yes\"";
		}
		
		if($ufdbguardConfig["url-lookup-result-when-fatal-error"]==1){
			$conf[]="url-lookup-result-when-fatal-error deny";
			$conf[]="redirect-fatal-error \"$this->SquidGuardIPWeb?fatalerror=yes\"";
		}
		
		if($ufdbguardConfig["check-proxy-tunnel"]==1){
			$conf[]="check-proxy-tunnels queue-checks";
		}
				
		
		while (list ($key, $line) = each ($ufdbguardConfig) ){
				if($line==0){$ufdbguardConfig[$key]="off";}
				if($line==1){$ufdbguardConfig[$key]="on";}
				if($line==null){$ufdbguardConfig[$key]="off";}
			}
			
		$conf[]="logblock on";
		$conf[]="logall off";
		$conf[]="max-logfile-size  20000000";
		$conf[]="analyse-uncategorised-urls off";
		$conf[]="safe-search on";
		$conf[]="";
 		$conf[]=$sources;
 		$conf[]=$times;
 		$conf[]=$categories;
 		$conf[]=$acls;				
		
 		return @implode("\n", $conf);
		
	}
	
	private function build_times(){
		if($GLOBALS["VERBOSE"]){echo "Starting......: ufdbGuard build TIMES ....\n";}
		$q=new mysql_squid_builder();
		$sql="SELECT ID,TimeSpace FROM webfilter_rules WHERE enabled=1";
		$results=$q->QUERY_SQL($sql);
		if(!$q->ok){echo "Starting......: ufdbGuard fatal error $q->mysql_error\n";}
		
		while($ligne=mysql_fetch_array($results,MYSQL_ASSOC)){
			$TimeSpace=unserialize(base64_decode($ligne["TimeSpace"]));
			if(!is_array($TimeSpace)){continue;}
			if(!is_array($TimeSpace["TIMES"])){continue;}
			if($TimeSpace["RuleMatchTime"]==null){$TimeSpace["RuleMatchTime"]="none";}
			if($TimeSpace["RuleAlternate"]==null){$TimeSpace["RuleAlternate"]="none";}	
			if($TimeSpace["RuleMatchTime"]=="none"){continue;}
			if(count($TimeSpace["TIMES"])==0){continue;}
			$f[]="time timeR{$ligne["ID"]} {";
			$R=array();
			while (list ($TIMEID, $array) = each ($TimeSpace["TIMES"]) ){
				if(count($array["DAYS"])==0){continue;}
				$dd=array();
				while (list ($day, $val) = each ($array["DAYS"])){if($val==1){$dd[]=$day;}}
				if(count($dd)==0){continue;}
				if(strlen($array["BEGINH"])==1){$array["BEGINH"]="0{$array["BEGINH"]}";}
				if(strlen($array["BEGINM"])==1){$array["BEGINM"]="0{$array["BEGINM"]}";}
				if(strlen($array["ENDH"])==1){$array["ENDH"]="0{$array["ENDH"]}";}
				if(strlen($array["ENDM"])==1){$array["ENDM"]="0{$array["ENDM"]}";}
				$R[]="\tweekly ".@implode("", $dd)." {$array["BEGINH"]}:{$array["BEGINM"]} - {$array["ENDH"]}:{$array["ENDM"]}";
			}
			if(count($R)==0){continue;}
			$f[]=@implode("\n", $R);
			$f[]="}";
			if($TimeSpace["RuleMatchTime"]=="inside"){$TimeSpace["RuleMatchTime"]="within";}
			$GLOBALS["TIMESRULES"][$ligne["ID"]]["MATCH"]=$TimeSpace["RuleMatchTime"];
			$GLOBALS["TIMESRULES"][$ligne["ID"]]["NEXT"]=$TimeSpace["RuleAlternate"];
			
		}
		
		return @implode("\n", $f);
		
		
	}
	
	private function members_from_activedirectory($ID){
		$sql="SELECT dn FROM webfilter_group WHERE ID=$ID";
		$q=new mysql_squid_builder();
		$ligne=mysql_fetch_array($q->QUERY_SQL($sql));
		$dn=base64_decode($ligne["dn"]);
		$sql="SELECT activedirectory_users.samaccountname FROM activedirectory_users,activedirectory_groups
		WHERE activedirectory_groups.userdn=activedirectory_users.dn AND activedirectory_groups.groupdn='$dn'";
		if($GLOBALS["VERBOSE"]){echo "Starting......: DansGuardian :$sql\n";}
		$q=new mysql();
		$results=$q->QUERY_SQL($sql,"artica_backup");
		if(!$q->ok){echo $q->mysql_error."\n";}
		while($ligne=mysql_fetch_array($results,MYSQL_ASSOC)){
				if($GLOBALS["VERBOSE"]){echo "Starting......: ufdbGuard Active Directory `{$ligne["samaccountname"]}`\n";}
				$f[]="\tuser\t\"{$ligne["samaccountname"]}\"";
		}
		if($GLOBALS["VERBOSE"]){echo "Starting......: ufdbGuard Active Directory group $ID return ". count($f) ." items\n";}
		return @implode("\n", $f)."\n";
		
	}	
	
	
	private function build_membersrule($ruleid){
		
		$array=array();
		$sql="SELECT webfilter_group.* FROM webfilter_group,webfilter_assoc_groups
		 WHERE webfilter_assoc_groups.group_id=webfilter_group.ID
		 AND webfilter_assoc_groups.webfilter_id=$ruleid
		 AND webfilter_group.enabled=1";
		
		$q=new mysql_squid_builder();
		$results=$q->QUERY_SQL($sql);
		
		if($GLOBALS["VERBOSE"]){writelogs("$ruleid has ".mysql_num_rows($results)." groups",__CLASS__.'/'.__FUNCTION__,__FILE__,__LINE__);}
		
		
		while($ligne=mysql_fetch_array($results,MYSQL_ASSOC)){
			$groupname=$ligne["groupname"];
			if($GLOBALS["VERBOSE"]){writelogs("$groupname LDAP?={$ligne["localldap"]}",__CLASS__.'/'.__FUNCTION__,__FILE__,__LINE__);}
			if($ligne["localldap"]==0){
				$gp=new groups($ligne["gpid"]);
				while (list ($num, $member) = each ($gp->members)){
					if(trim($member)==null){continue;}
					if(strpos($member, "$")>0){continue;}
					$array[]="\tuser\t\"$member\"";
					
				}
			}
			
		if($ligne["localldap"]==2){$array[]=$this->members_from_activedirectory($ligne["ID"]);}
		
					
			
		$sql="SELECT * FROM webfilter_members WHERE enabled=1 AND groupid={$ligne["ID"]}";
		$results2=$q->QUERY_SQL($sql);
		if($GLOBALS["VERBOSE"]){echo "Starting......: ufdbGuard $groupname({$ligne["ID"]}) webfilter_members = ". mysql_num_rows($results2)." items\n";}
		while($ligne2=mysql_fetch_array($results2,MYSQL_ASSOC)){
			if(trim($ligne2["pattern"])==null){continue;}
			if($GLOBALS["VERBOSE"]){writelogs("$groupname {$ligne2["pattern"]}={$ligne2["membertype"]}",__CLASS__.'/'.__FUNCTION__,__FILE__,__LINE__);}
			if($ligne2["membertype"]==0){$array[]="\tip\t{$ligne2["pattern"]}";}
			if($ligne2["membertype"]==2){$array[]="\tip\t{$ligne2["pattern"]}";}
			if($ligne2["membertype"]==1){$array[]="\tuser\t\"{$ligne2["pattern"]}\"";}			
			}
			
			
			
		}
		
		if(count($array)>0){return @implode("\n", $array);}
		
	}
	
	
	private function build_sources(){
		if($GLOBALS["VERBOSE"]){echo "Starting......: ufdbGuard build SOURCES ....\n";}
		$q=new mysql_squid_builder();
		
		$sql="SELECT ID,groupname FROM webfilter_rules WHERE enabled=1";
		$results=$q->QUERY_SQL($sql);
		while($ligne=mysql_fetch_array($results,MYSQL_ASSOC)){
			$RULE_ID=$ligne["ID"];
			$rulename=$ligne["groupname"];
			$members=$this->build_membersrule($RULE_ID);
			if($members==null){
				if($GLOBALS["VERBOSE"]){echo "Starting......: ufdbGuard skip `$rulename` (no members)\n";}
				continue;
			}
			$rulename=str_replace(" ", "-", $rulename);
			$array[]="source \"$rulename\" {";
			$array[]=$members;
			$array[]="}";
			$array[]="";
			$GLOBALS["SRC"][$ligne["ID"]]=$rulename;
			
		}

		return @implode("\n", $array);
		
		}
		
	function build_categories(){
		$q=new mysql_squid_builder();
		$main_path="/var/lib/squidguard";
		$sql="SELECT category FROM webfilter_blks GROUP BY category";
		$results=$q->QUERY_SQL($sql);
		$add_ufdbgard_secu=false;
		$sock=new sockets();
		while($ligne=mysql_fetch_array($results,MYSQL_ASSOC)){
			$category=$ligne["category"];
			
			
			$CountDeMembers=0;
			$table="category_".$q->category_transform_name($category);
			$BASETLSE="/var/lib/ftpunivtlse1fr/".$q->category_transform_name_toulouse($category);
			$categorypathTLSE="$BASETLSE/domains.ufdb";
			$categorypathTLSEUrls="$BASETLSE/urls";
			
			
			$categoryNameTLSE="tls".$q->category_transform_name_toulouse($category);
			if(!preg_match("#^category_(.+)#", $table,$re)){continue;}
			$categoryname=$re[1];
			if(!is_file("$main_path/$categoryname/domains")){
				$GLOBALS["CATEGORIES_SKIPPED"][$categoryname]=true;
				$order="COMPILEDB:$category";$md5=md5($order);
				$q->QUERY_SQL("INSERT IGNORE INTO framework_orders (`zmd5`,`ORDER`) VALUES('$md5','$order')");
				if(!$q->ok){if(strpos($q->mysql_error, "doesn't exist")>0){$q->CheckTables();$q->QUERY_SQL("INSERT IGNORE INTO framework_orders (`zmd5`,`ORDER`) VALUES('$md5','$order')");}}
				ufdbguard_admin_events("skip category $categoryname $main_path/$categoryname/domains no such file",__FUNCTION__,__FILE__,__LINE__,"config");
				continue;
			}
			
			
			if($this->EnableWebProxyStatsAppliance==0){
				if(!is_file("$main_path/$categoryname/domains.ufdb")){
					$GLOBALS["CATEGORIES_SKIPPED"][$categoryname]=true;
					ufdbguard_admin_events("skip category $categoryname $main_path/$categoryname/domains.ufdb no such file",__FUNCTION__,__FILE__,__LINE__,"config");
					continue;
				}
			}
			
			
			if($this->SquidDatabasesUtlseEnable==1){
				if(is_file($categorypathTLSE)){
					if(!is_file("$BASETLSE/expressions")){@file_put_contents("$BASETLSE/expressions", "\n");}
					$GLOBALS["UNIVTOULOUSE"][$categoryname]=$categoryNameTLSE;
					$array[]="category \"$categoryNameTLSE\" {";
					$categorypathTLSE=str_replace(".ufdb", "", $categorypathTLSE);
					$array[]="\tdomainlist\t\"$categorypathTLSE\"";
					$array[]="}\n";	
					
				}else{
					
				}
				
			}				

			
			
			
			$size=@filesize("$main_path/$categoryname/domains");
			if($size<20){
				$GLOBALS["CATEGORIES_SKIPPED"][$categoryname]=true;
				ufdbguard_admin_events("skip category $categoryname $main_path/$categoryname/domains $size bytes -> empty file",__FUNCTION__,__FILE__,__LINE__,"config");
				continue;
			}
			
			
			$categorynameText=$categoryname;
			if($categoryname=="agressive"){$categorynameText="agressivecat";}
			$GLOBALS["CATEGORIES_ADDED"][$categoryname]=true;

			if(!is_file("$main_path/$categoryname/expressions")){@file_put_contents("$main_path/$categoryname/expressions", "\n");}		
			$array[]="category \"$categorynameText\" {";
			$array[]="\tdomainlist\t\"$categoryname/domains\"";
			$array[]="\texpressionlist\t\"$categoryname/expressions\"";
			$array[]="}\n";
			
		
			
			

					
			
			
	
	}
	
			$ufdbguardConfig=unserialize(base64_decode($sock->GET_INFO("ufdbguardConfig")));
			if(!isset($ufdbguardConfig["enforce-https-official-certificate"])){$ufdbguardConfig["enforce-https-official-certificate"]=null;}
			if(!isset($ufdbguardConfig["enforce-https-with-hostname"])){$ufdbguardConfig["enforce-https-with-hostname"]=null;}
			if(!isset($ufdbguardConfig["https-prohibit-insecure-sslv2"])){$ufdbguardConfig["https-prohibit-insecure-sslv2"]=null;}
			
			
			if($ufdbguardConfig["enforce-https-with-hostname"]==null){$ufdbguardConfig["enforce-https-with-hostname"]=0;}
			if($ufdbguardConfig["enforce-https-official-certificate"]==null){$ufdbguardConfig["enforce-https-official-certificate"]=0;}
			if($ufdbguardConfig["https-prohibit-insecure-sslv2"]==null){$ufdbguardConfig["https-prohibit-insecure-sslv2"]=0;}			
			
			while (list ($key, $line) = each ($ufdbguardConfig) ){
				if($line==0){$ufdbguardConfig[$key]="off";}
				if($line==1){$ufdbguardConfig[$key]="on";}
				if($line==null){$ufdbguardConfig[$key]="off";}
			}
			
			if($ufdbguardConfig["enforce-https-with-hostname"]=="on"){$add_ufdbgard_secu=true;}
			if($ufdbguardConfig["enforce-https-official-certificate"]=="on"){$add_ufdbgard_secu=true;}
			if($ufdbguardConfig["https-prohibit-insecure-sslv2"]=="on"){$add_ufdbgard_secu=true;}
			if($add_ufdbgard_secu){$GLOBALS["ADD_UFDBGUARD_SSL"]=true;}
			
			$array[]="\ncategory security {";
			$array[]="\toption enforce-https-with-hostname {$ufdbguardConfig["enforce-https-with-hostname"]}";
			$array[]="\toption enforce-https-official-certificate {$ufdbguardConfig["enforce-https-official-certificate"]}";
			$array[]="\toption https-prohibit-insecure-sslv2 {$ufdbguardConfig["https-prohibit-insecure-sslv2"]}";
			$array[]="}\n";	
			
			$array[]="\ncategory checked{";
			$array[]="domainlist	checked/domains";
			@mkdir("/var/lib/squidguard/checked",755,true);
			$array[]="}\n";
	
			return @implode("\n", $array);
	
	

	}
	
	function build_acls(){
		$allows=array();
		$banns=array();		
		$q=new mysql_squid_builder();
		$time=null;
		
		if(!preg_match("#^http.*?\/\/#",$this->SquidGuardIPWeb)){
			$this->SquidGuardIPWeb="https://$this->SquidGuardIPWeb";
			if(!preg_match("#squidguard\.php#",$this->SquidGuardIPWeb)){$this->SquidGuardIPWeb=$this->SquidGuardIPWeb."/exec.squidguard.php?$redirect_pattern";}
		}		
		
		$array[]="acl{";
		$sql="SELECT category,modeblk FROM webfilter_blks WHERE webfilter_id=0";
		$results=$q->QUERY_SQL($sql);
		echo "Starting......: ufdbGuard build ACLS for default rule ". mysql_num_rows($results)." items...\n";
		
		while($ligne=mysql_fetch_array($results,MYSQL_ASSOC)){
			$category=trim($ligne["category"]);
			if($category==null){continue;}
			$category=str_replace("/", "_", $category);
			$category=str_replace("-", "_", $category);
			$category=str_replace(" ", "_", $category);
			if($category=="agressive"){$category="agressivecat";}
			if(isset($GLOBALS["CATEGORIES_SKIPPED"][$category])){continue;}
			if(!isset($GLOBALS["CATEGORIES_ADDED"][$category])){continue;}
			
			if($ligne["modeblk"]==0){
				$banns[]="!$category";
				if(isset($GLOBALS["UNIVTOULOUSE"][$category])){$banns[]="!{$GLOBALS["UNIVTOULOUSE"][$category]}";}
			}
			if($ligne["modeblk"]==1){
				$allows[]="$category";
				if(isset($GLOBALS["UNIVTOULOUSE"][$category])){$allows[]="{$GLOBALS["UNIVTOULOUSE"][$category]}";}
			}			
			
			
		}
		if(isset($GLOBALS["TIMESRULES"][0])){
			if($GLOBALS["TIMESRULES"][0]["MATCH"]<>null){
			$time=" {$GLOBALS["TIMESRULES"][0]["MATCH"]} timeR0 ";
			echo "Starting......: ufdbGuard build ACLS default rule to time timeR0...\n";
			}else{
			echo "Starting......: ufdbGuard build ACLS default rule has no time...\n";
			}
		}
		
		
		$array[]="\t\"default\"$time{";
		$array[]="\t\tpass ".trim(@implode(" ", $allows)." ".@implode(" ", $banns))." all";
		$redirect_pattern="rule-id=0&clientaddr=%a&clientname=%n&clientuser=%i&clientgroup=%s&targetgroup=%t&url=%u";
		$array[]="\t\tredirect $this->SquidGuardIPWeb?$redirect_pattern";
		$array[]="\t}";	

		if(is_array($GLOBALS["SRC"])){
			while (list ($RULE_ID,$groupname) = each ($GLOBALS["SRC"]) ){
				echo "Starting......: ufdbGuard build ACLS `$groupname` ID:$RULE_ID\n";
				$allows=array();
				$banns=array();
				$time=null;
				$else=null;
				echo "Starting......: ufdbGuard rule `$groupname`\n";
				
				if($GLOBALS["TIMESRULES"][$RULE_ID]["MATCH"]<>null){
						$time=" {$GLOBALS["TIMESRULES"][$RULE_ID]["MATCH"]} timeR{$RULE_ID} ";
					}else{
					echo "Starting......: ufdbGuard build ACLS rule:`$groupname` $RULE_ID rule has no time...\n";
				}			
				
				if(isset($GLOBALS["TIMESRULES"][$RULE_ID]["NEXT"])){
					if(is_numeric($GLOBALS["TIMESRULES"][$RULE_ID]["NEXT"])){
					$else=" else {\n".$this->compile_categories_fromruleid($GLOBALS["TIMESRULES"][$RULE_ID]["NEXT"])."\n\t\tredirect $this->SquidGuardIPWeb?$redirect_pattern\n\t}";
					}
				}
				
				$groupname=str_replace(" ", "-", $groupname);
				$array[]="\t\"$groupname\"$time{";
				$array[]=$this->compile_categories_fromruleid($RULE_ID);
				$redirect_pattern="rule-id=$RULE_ID&clientaddr=%a&clientname=%n&clientuser=%i&clientgroup=%s&targetgroup=%t&url=%u";
				$array[]="\t\tredirect $this->SquidGuardIPWeb?$redirect_pattern";
				$array[]="\t}$else\n";	
			}
			$array[]="}";
		}
		return @implode("\n", $array);
		
		
	}
	
	private function compile_categories_fromruleid($RULE_ID){
		$q=new mysql_squid_builder();
		$sql="SELECT groupmode FROM webfilter_rules WHERE ID='$RULE_ID'";
		$ligne=mysql_fetch_array($q->QUERY_SQL($sql));
		if($ligne["groupmode"]==0){
			echo "Starting......: ufdbGuard rule:$RULE_ID deny all users...\n";
			return "\t\tpass none";
		}
		
		$sql="SELECT * FROM webfilter_blks WHERE webfilter_id=$RULE_ID";
		$q=new mysql_squid_builder();
		$results2=$q->QUERY_SQL($sql);
		
		if(!$q->ok){echo $q->mysql_error."\n$sql\n";}
		while($blks=mysql_fetch_array($results2,MYSQL_ASSOC)){
				if(isset($ARRAY["{$blks["modeblk"]}$RULE_ID{$blks["category"]}"])){continue;}
				$category=$q->CategoryShellEscape($blks["category"]);
				if($category=="agressive"){$category="agressivecat";}
				
				
				if(!isset($GLOBALS["CATEGORIES_ADDED"][$category])){
					if($GLOBALS["VERBOSE"]){echo "Starting......: ufdbGuard ruleid:$RULE_ID category `$category` ({$blks["category"]}) is skipped\n";}
					continue;
				}
				
				if($blks["modeblk"]==0){
					$banns[]="!$category";
					if(isset($GLOBALS["UNIVTOULOUSE"][$category])){$banns[]="!{$GLOBALS["UNIVTOULOUSE"][$category]}";}
				
				}
				if($blks["modeblk"]==1){
					$allows[]="$category";
					if(isset($GLOBALS["UNIVTOULOUSE"][$category])){$allows[]="{$GLOBALS["UNIVTOULOUSE"][$category]}";}
				}
				$ARRAY["{$blks["modeblk"]}$RULE_ID{$blks["category"]}"]=true;
			}
			
		return "\t\tpass ".trim(@implode(" ", $allows)." ".@implode(" ", $banns))." all";
		
	}
	
	
	
	
	function compile_category($category){
		if($category=="phishtank"){
			$main_path="/var/lib/squidguard/phishtank";
			$this->UfdbGenTable($main_path,$category);
			$compiledbs_took=$unix->distanceOfTimeInWords($t1,time(),true);
			ufdbguard_admin_events("$category compilation done\nWebsites:$inserted\nSQL took:$mysqlquerry_took\nWrite to disk took:$writetodisk_took\nUFDB Compilation took:$compiledbs_took",__FUNCTION__,__FILE__,__LINE__,"compile");
			return;
		}
		if($this->EnableRemoteStatisticsAppliance==1){ufdbguard_admin_events("Category $category must be compiled by the statistics appliance (aborting)",__FUNCTION__,__FILE__,__LINE__,"compile");return;}
		$q=new mysql_squid_builder();
		$main_path="/var/lib/squidguard/$category";
		
		$tablename="category_$category";
		if(!$q->TABLE_EXISTS($tablename)){ufdbguard_admin_events("Failed to compile $category no such table",__FUNCTION__,__FILE__,__LINE__,"compile");return;}
		
		$sql="SELECT * FROM `$tablename` WHERE enabled=1";
		$q=new mysql_squid_builder();
		$unix=new unix();
		$t1=time();
		$results=$q->QUERY_SQL($sql);
		$mysqlquerry_took=$unix->distanceOfTimeInWords($t1,time(),true);
		if(!$q->ok){ufdbguard_admin_events("Failed to compile $category $q->mysql_error",__FUNCTION__,__FILE__,__LINE__,"compile");echo $q->mysql_error."\n";return ;}
		$num=mysql_num_rows($results);
		if($num==0){ufdbguard_admin_events("Category $category has no data a null file will be created",__FUNCTION__,__FILE__,__LINE__,"compile");}
		
		
		@mkdir($main_path,0755,true);
		$fh = fopen($main_path."/domains", 'w');
		
		$skipped=0;
		$inserted=0;
		$t1=time();
		while($ligne=@mysql_fetch_array($results,MYSQL_ASSOC)){
			$datas=$ligne["pattern"];
			if($datas==null){$skipped++;continue;}
			if(!$this->VerifyDomainCompiledPattern($datas)){$skipped++;continue;}
			$inserted++;		
			fwrite($fh, "{$ligne["pattern"]}\n");
		}
		fclose($fh);
		$writetodisk_took=$unix->distanceOfTimeInWords($t1,time(),true);
		
		if(!is_file("$main_path/urls")){shell_exec("/bin/touch $main_path/urls");}
		$t1=time();
		$this->UfdbGenTable($main_path,$category);
		$compiledbs_took=$unix->distanceOfTimeInWords($t1,time(),true);
		ufdbguard_admin_events("$category compilation done\nWebsites:$inserted\nSQL took:$mysqlquerry_took\nWrite to disk took:$writetodisk_took\nUFDB Compilation took:$compiledbs_took",__FUNCTION__,__FILE__,__LINE__,"compile");
		
				
	}
	
	public function UfdbGenTable($directory,$category){
		$unix=new unix();
		$ufdbGenTable=$unix->find_program("ufdbGenTable");
		if(strlen($ufdbGenTable)<strlen("ufdbGenTable")){return;}
		$category_compile=$category;
		if(strlen($category_compile)>15){
			$category_compile=str_replace("recreation_","recre_",$category_compile);
			$category_compile=str_replace("automobile_","auto_",$category_compile);
			$category_compile=str_replace("finance_","fin_",$category_compile);
			if(strlen($category_compile)>15){
				$category_compile=str_replace("_", "", $category_compile);
				if(strlen($category_compile)>15){$category_compile=substr($category_compile, strlen($category_compile)-15,15);}
			}
		}	
		
		if(!is_file("$directory/urls")){@file_put_contents("$directory/urls", "\n");}
		
		$u=" -u $directory/urls";
		$d=" -d $directory/domains";
		$EXEC_NICE=$unix->EXEC_NICE();
		$cmd="$EXEC_NICE$ufdbGenTable -n -D -W -t $category_compile$d$u";
		shell_exec($cmd);
	}
	

	private function VerifyDomainCompiledPattern($pattern){
		if(!preg_match("#^(.+?)\.(.+)#",$pattern)){return false;}
		return true;
	}	
	
	
}