/*
 * Audit VFS module.
 * Copyright (C) Anaoliy Okhotnikov, 2005-2006
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#define MY_AUDIT_CONNECT 10
#define MY_AUDIT_DISCONNECT 20
#define MY_AUDIT_DISK_FREE 30
#define MY_AUDIT_GET_QUOTA 40
#define MY_AUDIT_SET_QUOTA 50
#define MY_AUDIT_GET_SHADOW_COPY_DATA 60
#define MY_AUDIT_STATVFS 70
#define MY_AUDIT_OPENDIR 80
#define MY_AUDIT_READDIR 90
#define MY_AUDIT_SEEKDIR 100
#define MY_AUDIT_TELLDIR 110
#define MY_AUDIT_REWINDDIR 120
#define MY_AUDIT_MKDIR 130
#define MY_AUDIT_RMDIR 140
#define MY_AUDIT_CLOSEDIR 150
#define MY_AUDIT_OPEN 160
#define MY_AUDIT_CLOSE 170
#define MY_AUDIT_READ 180
#define MY_AUDIT_PREAD 190
#define MY_AUDIT_WRITE 200
#define MY_AUDIT_PWRITE 210
#define MY_AUDIT_LSEEK 220
#define MY_AUDIT_RENAME 230
#define MY_AUDIT_FSYNC 240
#define MY_AUDIT_STAT 250
#define MY_AUDIT_FSTAT 260
#define MY_AUDIT_LSTAT 270
#define MY_AUDIT_UNLINK 280
#define MY_AUDIT_CHMOD 290
#define MY_AUDIT_FCHMOD 300
#define MY_AUDIT_CHOWN 310
#define MY_AUDIT_FCHOWN 320
#define MY_AUDIT_CHDIR 330
#define MY_AUDIT_GETWD 340
#define MY_AUDIT_UTIME 350
#define MY_AUDIT_FTRUNCATE 360
#define MY_AUDIT_LOCK 370
#define MY_AUDIT_SYMLINK 380
#define MY_AUDIT_READLINK 390
#define MY_AUDIT_LINK 400
#define MY_AUDIT_MKNOD 410
#define MY_AUDIT_REALPATH 420
#define MY_AUDIT_FGET_NT_ACL 430
#define MY_AUDIT_GET_NT_ACL 440
#define MY_AUDIT_FSET_NT_ACL 450
#define MY_AUDIT_SET_NT_ACL 460
#define MY_AUDIT_CHMOD_ACL 470
#define MY_AUDIT_FCHMOD_ACL 480
#define MY_AUDIT_SYS_ACL_GET_ENTRY 490
#define MY_AUDIT_SYS_ACL_GET_TAG_TYPE 500
#define MY_AUDIT_SYS_ACL_GET_PERMSET 510
#define MY_AUDIT_SYS_ACL_GET_QUALIFIER 520
#define MY_AUDIT_SYS_ACL_GET_FILE 530
#define MY_AUDIT_SYS_ACL_GET_FD 540
#define MY_AUDIT_SYS_ACL_CLEAR_PERMS 550
#define MY_AUDIT_SYS_ACL_ADD_PERM 560
#define MY_AUDIT_SYS_ACL_TO_TEXT 570
#define MY_AUDIT_SYS_ACL_INIT 580
#define MY_AUDIT_SYS_ACL_CREATE_ENTRY 590
#define MY_AUDIT_SYS_ACL_SET_TAG_TYPE 600
#define MY_AUDIT_SYS_ACL_SET_QUALIFIER 610
#define MY_AUDIT_SYS_ACL_SET_PERMSET 620
#define MY_AUDIT_SYS_ACL_VALID 630
#define MY_AUDIT_SYS_ACL_SET_FILE 640
#define MY_AUDIT_SYS_ACL_SET_FD 650
#define MY_AUDIT_SYS_ACL_DELETE_DEF_FILE 660
#define MY_AUDIT_SYS_ACL_GET_PERM 670
#define MY_AUDIT_SYS_ACL_FREE_TEXT 680
#define MY_AUDIT_SYS_ACL_FREE_ACL 690
#define MY_AUDIT_SYS_ACL_FREE_QUALIFIER 700
#define MY_AUDIT_GETXATTR 710
#define MY_AUDIT_LGETXATTR 720
#define MY_AUDIT_FGETXATTR 730
#define MY_AUDIT_LISTXATTR 740
#define MY_AUDIT_LLISTXATTR 750
#define MY_AUDIT_FLISTXATTR 760
#define MY_AUDIT_REMOVEXATTR 770
#define MY_AUDIT_LREMOVEXATTR 780
#define MY_AUDIT_FREMOVEXATTR 790
#define MY_AUDIT_SETXATTR 800
#define MY_AUDIT_LSETXATTR 810
#define MY_AUDIT_FSETXATTR 820
#define MY_AUDIT_AIO_READ 830
#define MY_AUDIT_AIO_WRITE 840
#define MY_AUDIT_AIO_RETURN 850
#define MY_AUDIT_AIO_CANCEL 860
#define MY_AUDIT_AIO_ERROR 870
#define MY_AUDIT_AIO_FSYNC 880
#define MY_AUDIT_AIO_SUSPEND 890
